rm(list=ls())
dev.off()
# setwd("C:/Users/mapsossa/Box Sync/2. Project/190601 - Daily Peak Loads/code")
setwd("C:/Users/mapso/OneDrive/Desktop/Daily peak temperature")

rm(list=c('load_02','load_03','load_04','load_05','load_06','load_07','load_08','load_09', 'load_10', 'load_11', 'load_12','load_13', 'load_14','load_15','load_16'))
rm(list=c('load.02','load.03','load.04','load.05','load.06','load.07','load.08','load.09', 'load.10', 'load.11', 'load.12','load.13', 'load.14','load.15','load.16'))
rm(list='lm.pop')

rm(list=c('gcm.2017', 'gcm'))
rm(list='temp.data')
rm(list='temp.data.02')
rm(list='temp.mean')
rm(list='gcm.daily.ave')
rm(list='time')
rm(list='col_numeric')
rm(list='summer.avg')
rm(list='summer.avg.2017')
rm(list='t.jun')
rm(list='t.sep')
rm(list='m')
rm(list='m.2017')
rm(list='load.all')
rm(list=c('temp.data.02', 'temp.data'))
rm(list='i')
rm(list='eda1.lm')
rm(list='peak')

library(ismev)
library(ggplot2)
library(evd)
library(EnvStats)
library(dplyr)
library(tidyverse)
library(lubridate)
library(Rcpp)
library(data.table)

options(digits = 10)
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right

#############################################################################
## Analysis starts
#############################################################################
load("data_load.RData")

# demand saving from EE/DR in Austin * 100/23 from 2007 to 2016
ee.ds = c(99.44,	199.89,	301.90,	402.81,	503.36,	606.88,	705.45,	803.32,	903.53,	1000.56)

# load without demand saving
data[data$year==2007,]$load - ee.ds[1]
data[data$year==2008,]$load - ee.ds[2]
data[data$year==2009,]$load - ee.ds[3]
data[data$year==2010,]$load - ee.ds[4]
data[data$year==2011,]$load - ee.ds[5]
data[data$year==2012,]$load - ee.ds[6]
data[data$year==2013,]$load - ee.ds[7]
data[data$year==2014,]$load - ee.ds[8]
data[data$year==2015,]$load - ee.ds[9]
data[data$year==2016,]$load - ee.ds[10]

# temp: annual peak temperature (not GCM)
head(temp)
temp = temp[temp$year >=2002, ]
temp = temp[temp$year <=2016, ]
temp.annual.peak = matrix(NA, length(unique(temp$year)), 1)
temp.annual.peak[1] = max(temp[temp$year == 2002,]$temp.daily.max) #62 days
temp.annual.peak[2] = max(temp[temp$year == 2003,]$temp.daily.max)
temp.annual.peak[3] = max(temp[temp$year == 2004,]$temp.daily.max)
temp.annual.peak[4] = max(temp[temp$year == 2005,]$temp.daily.max)
temp.annual.peak[5] = max(temp[temp$year == 2006,]$temp.daily.max)
temp.annual.peak[6] = max(temp[temp$year == 2007,]$temp.daily.max)
temp.annual.peak[7] = max(temp[temp$year == 2008,]$temp.daily.max)
temp.annual.peak[8] = max(temp[temp$year == 2009,]$temp.daily.max)
temp.annual.peak[9] = max(temp[temp$year == 2010,]$temp.daily.max)
temp.annual.peak[10] = max(temp[temp$year == 2011,]$temp.daily.max)
temp.annual.peak[11] = max(temp[temp$year == 2012,]$temp.daily.max)
temp.annual.peak[12] = max(temp[temp$year == 2013,]$temp.daily.max)
temp.annual.peak[13] = max(temp[temp$year == 2014,]$temp.daily.max)
temp.annual.peak[14] = max(temp[temp$year == 2015,]$temp.daily.max)
temp.annual.peak[15] = max(temp[temp$year == 2016,]$temp.daily.max)
data$temp.annual.peak = rep(temp.annual.peak, each=62)

temp.annual.peak.sd = matrix(NA, length(unique(temp$year)), 1)
temp.annual.peak.sd[1] = sd(temp[temp$year == 2002,]$temp.daily.max) #62 days
temp.annual.peak.sd[2] = sd(temp[temp$year == 2003,]$temp.daily.max)
temp.annual.peak.sd[3] = sd(temp[temp$year == 2004,]$temp.daily.max)
temp.annual.peak.sd[4] = sd(temp[temp$year == 2005,]$temp.daily.max)
temp.annual.peak.sd[5] = sd(temp[temp$year == 2006,]$temp.daily.max)
temp.annual.peak.sd[6] = sd(temp[temp$year == 2007,]$temp.daily.max)
temp.annual.peak.sd[7] = sd(temp[temp$year == 2008,]$temp.daily.max)
temp.annual.peak.sd[8] = sd(temp[temp$year == 2009,]$temp.daily.max)
temp.annual.peak.sd[9] = sd(temp[temp$year == 2010,]$temp.daily.max)
temp.annual.peak.sd[10] = sd(temp[temp$year == 2011,]$temp.daily.max)
temp.annual.peak.sd[11] = sd(temp[temp$year == 2012,]$temp.daily.max)
temp.annual.peak.sd[12] = sd(temp[temp$year == 2013,]$temp.daily.max)
temp.annual.peak.sd[13] = sd(temp[temp$year == 2014,]$temp.daily.max)
temp.annual.peak.sd[14] = sd(temp[temp$year == 2015,]$temp.daily.max)
temp.annual.peak.sd[15] = sd(temp[temp$year == 2016,]$temp.daily.max)
data$temp.annual.peak.sd = rep(temp.annual.peak.sd, each=62)

colMax <- function(data) sapply(data, max, na.rm = TRUE)

head(GCM)
GCM[GCM$year == 2002,]

GCM.summer.avg = matrix(NA, length(unique(GCM$year)), 1)
GCM.summer.avg[1] = mean(c(as.matrix(GCM[GCM$year == 2002,c(4:45)])))
GCM.summer.avg[2] = mean(c(as.matrix(GCM[GCM$year == 2003,c(4:45)])))
GCM.summer.avg[3] = mean(c(as.matrix(GCM[GCM$year == 2004,c(4:45)])))
GCM.summer.avg[4] = mean(c(as.matrix(GCM[GCM$year == 2005,c(4:45)])))
GCM.summer.avg[5] = mean(c(as.matrix(GCM[GCM$year == 2006,c(4:45)])))
GCM.summer.avg[6] = mean(c(as.matrix(GCM[GCM$year == 2007,c(4:45)])))
GCM.summer.avg[7] = mean(c(as.matrix(GCM[GCM$year == 2008,c(4:45)])))
GCM.summer.avg[8] = mean(c(as.matrix(GCM[GCM$year == 2009,c(4:45)])))
GCM.summer.avg[9] = mean(c(as.matrix(GCM[GCM$year == 2010,c(4:45)])))
GCM.summer.avg[10] = mean(c(as.matrix(GCM[GCM$year == 2011,c(4:45)])))
GCM.summer.avg[11] = mean(c(as.matrix(GCM[GCM$year == 2012,c(4:45)])))
GCM.summer.avg[12] = mean(c(as.matrix(GCM[GCM$year == 2013,c(4:45)])))
GCM.summer.avg[13] = mean(c(as.matrix(GCM[GCM$year == 2014,c(4:45)])))
GCM.summer.avg[14] = mean(c(as.matrix(GCM[GCM$year == 2015,c(4:45)])))
GCM.summer.avg[15] = mean(c(as.matrix(GCM[GCM$year == 2016,c(4:45)])))
data$GCM.summer.avg = rep(GCM.summer.avg, each=62)


# GCM: average value of annual peak temperature from 42 GCMs
GCM.summer.sd = matrix(NA, length(unique(GCM$year)), 1)
GCM.summer.sd[1] = sd(c(as.matrix(GCM[GCM$year == 2002,c(4:45)])))
GCM.summer.sd[2] = sd(c(as.matrix(GCM[GCM$year == 2003,c(4:45)])))
GCM.summer.sd[3] = sd(c(as.matrix(GCM[GCM$year == 2004,c(4:45)])))
GCM.summer.sd[4] = sd(c(as.matrix(GCM[GCM$year == 2005,c(4:45)])))
GCM.summer.sd[5] = sd(c(as.matrix(GCM[GCM$year == 2006,c(4:45)])))
GCM.summer.sd[6] = sd(c(as.matrix(GCM[GCM$year == 2007,c(4:45)])))
GCM.summer.sd[7] = sd(c(as.matrix(GCM[GCM$year == 2008,c(4:45)])))
GCM.summer.sd[8] = sd(c(as.matrix(GCM[GCM$year == 2009,c(4:45)])))
GCM.summer.sd[9] = sd(c(as.matrix(GCM[GCM$year == 2010,c(4:45)])))
GCM.summer.sd[10] = sd(c(as.matrix(GCM[GCM$year == 2011,c(4:45)])))
GCM.summer.sd[11] = sd(c(as.matrix(GCM[GCM$year == 2012,c(4:45)])))
GCM.summer.sd[12] = sd(c(as.matrix(GCM[GCM$year == 2013,c(4:45)])))
GCM.summer.sd[13] = sd(c(as.matrix(GCM[GCM$year == 2014,c(4:45)])))
GCM.summer.sd[14] = sd(c(as.matrix(GCM[GCM$year == 2015,c(4:45)])))
GCM.summer.sd[15] = sd(c(as.matrix(GCM[GCM$year == 2016,c(4:45)])))
data$GCM.summer.sd = rep(GCM.summer.sd, each=62)

# GCM: average value of annual peak temperature from 42 GCMs
GCM.annual.peak = matrix(NA, length(unique(GCM$year)), 1)
GCM.annual.peak[1] = mean(colMax(GCM[GCM$year == 2002,c(4:45)]))
GCM.annual.peak[2] = mean(colMax(GCM[GCM$year == 2003,c(4:45)]))
GCM.annual.peak[3] = mean(colMax(GCM[GCM$year == 2004,c(4:45)]))
GCM.annual.peak[4] = mean(colMax(GCM[GCM$year == 2005,c(4:45)]))
GCM.annual.peak[5] = mean(colMax(GCM[GCM$year == 2006,c(4:45)]))
GCM.annual.peak[6] = mean(colMax(GCM[GCM$year == 2007,c(4:45)]))
GCM.annual.peak[7] = mean(colMax(GCM[GCM$year == 2008,c(4:45)]))
GCM.annual.peak[8] = mean(colMax(GCM[GCM$year == 2009,c(4:45)]))
GCM.annual.peak[9] = mean(colMax(GCM[GCM$year == 2010,c(4:45)]))
GCM.annual.peak[10] = mean(colMax(GCM[GCM$year == 2011,c(4:45)]))
GCM.annual.peak[11] = mean(colMax(GCM[GCM$year == 2012,c(4:45)]))
GCM.annual.peak[12] = mean(colMax(GCM[GCM$year == 2013,c(4:45)]))
GCM.annual.peak[13] = mean(colMax(GCM[GCM$year == 2014,c(4:45)]))
GCM.annual.peak[14] = mean(colMax(GCM[GCM$year == 2015,c(4:45)]))
GCM.annual.peak[15] = mean(colMax(GCM[GCM$year == 2016,c(4:45)]))
data$GCM.annual.peak = rep(GCM.annual.peak, each=62)

# GCM: average value of annual peak temperature from 42 GCMs
GCM.annual.peak.sd = matrix(NA, length(unique(GCM$year)), 1)
GCM.annual.peak.sd[1] = sd(colMax(GCM[GCM$year == 2002,c(4:45)]))
GCM.annual.peak.sd[2] = sd(colMax(GCM[GCM$year == 2003,c(4:45)]))
GCM.annual.peak.sd[3] = sd(colMax(GCM[GCM$year == 2004,c(4:45)]))
GCM.annual.peak.sd[4] = sd(colMax(GCM[GCM$year == 2005,c(4:45)]))
GCM.annual.peak.sd[5] = sd(colMax(GCM[GCM$year == 2006,c(4:45)]))
GCM.annual.peak.sd[6] = sd(colMax(GCM[GCM$year == 2007,c(4:45)]))
GCM.annual.peak.sd[7] = sd(colMax(GCM[GCM$year == 2008,c(4:45)]))
GCM.annual.peak.sd[8] = sd(colMax(GCM[GCM$year == 2009,c(4:45)]))
GCM.annual.peak.sd[9] = sd(colMax(GCM[GCM$year == 2010,c(4:45)]))
GCM.annual.peak.sd[10] = sd(colMax(GCM[GCM$year == 2011,c(4:45)]))
GCM.annual.peak.sd[11] = sd(colMax(GCM[GCM$year == 2012,c(4:45)]))
GCM.annual.peak.sd[12] = sd(colMax(GCM[GCM$year == 2013,c(4:45)]))
GCM.annual.peak.sd[13] = sd(colMax(GCM[GCM$year == 2014,c(4:45)]))
GCM.annual.peak.sd[14] = sd(colMax(GCM[GCM$year == 2015,c(4:45)]))
GCM.annual.peak.sd[15] = sd(colMax(GCM[GCM$year == 2016,c(4:45)]))
data$GCM.annual.peak.sd = rep(GCM.annual.peak.sd, each=62)

data.origin  = data

# head(data)
data$temp.daily.max = scale(data$temp.daily.max)
data$temp.summer.avg = scale(data$temp.summer.avg)
data$temp.annual.peak = scale(data$temp.annual.peak)
data$temp.annual.peak.sd = scale(data$temp.annual.peak.sd)


data$GCM.daily.avg = scale(data$GCM.daily.avg)
data$GCM.summer.sd  = scale(data$GCM.summer.sd)
data$GCM.summer.avg = scale(data$GCM.summer.avg)
data$GCM.annual.peak = scale(data$GCM.annual.peak)
data$GCM.annual.peak.sd = scale(data$GCM.annual.peak.sd)

data$population = data$population/10000

unique(data$year)
length(unique(data$year))
train= data[data$year<=2010,]
test= data[data$year>=2011,]
names(train)


m.gcm.summer.avg <- attr(data$GCM.summer.avg, "scaled:center")
sd.gcm.summer.avg <- attr(data$GCM.summer.avg, "scaled:scale")

m.gcm.summer.sd <- attr(data$GCM.summer.sd, "scaled:center")
sd.gcm.summer.sd <- attr(data$GCM.summer.sd, "scaled:scale")

m.gcm.annual.peak.sd <- attr(data$GCM.annual.peak.sd, "scaled:center")
sd.gcm.annual.peak.sd <- attr(data$GCM.annual.peak.sd, "scaled:scale")

m.gcm.annual.peak <- attr(data$GCM.annual.peak, "scaled:center")
sd.gcm.annual.peak <- attr(data$GCM.annual.peak, "scaled:scale")

m.temp.annual.peak <- attr(data$temp.annual.peak, "scaled:center")
sd.temp.annual.peak <- attr(data$temp.annual.peak, "scaled:scale")

m.temp.annual.peak.sd <- attr(data$temp.annual.peak.sd, "scaled:center")
sd.temp.annual.peak.sd <- attr(data$temp.annual.peak.sd, "scaled:scale")

#############################################################################
## 1. Daily peak temperature: GEV
#############################################################################
temp.gev.m1 <- gev.fit(xdat = train$temp.daily.max, ydat = as.matrix(train), mul  = c(7), sigl = c(7)) 

#############################################################################
## 2. Daily peak load: GEV
#############################################################################
# GEV
load.gev.m1<- gev.fit(train$load, ydat= as.matrix(train), mul= c(4,8,9), sigl = c(4,8,9))

##############################################
# 3. population
##############################################
plot(data$year.std, data$population*1000, xlab="Year (2002:2016)", ylab="Population in thousands")
pop.tr = pop[1:9]

# year 2002:2010
year = 1:9
f1=SSlogis(year, 10000, -1, 100)
lines(year,f1,col=4)

###########################################################################
# for the population prediction for the prediction data set 
pop.final <- nlsLM(pop ~ 6000/(1 + exp(-(1:15 - b)/c)),
                   start = list( b=20, c=2),trace=T, 
                   control=nls.lm.control(maxiter = 1024))

b.final = coef(pop.final)[1]
c.final = coef(pop.final)[2]

pred.logis.fitted = 6000/(1 + exp(-(1:15 - b.final)/c.final))
pop.final.residual = pop - pred.logis.fitted
pred.logis.future = 6000/(1 + exp(-(16:40 - b.final)/c.final))
lines(16:40, pred.logis.future, type="l", col=2)

plot(unique(data.origin[complete.cases(data.origin),]$population), xlab="Year", ylab="Population (in thousands)", xlim=c(1,39), ylim = c(3000, 8000), xaxt = "n" )
axis(1, at=1:39, labels=c(2002:2040)) 
pred.logis.future.all = 6000/(1 + exp(-(1:40 - b.final)/c.final))
lines(pred.logis.future.all, type="l", col=2)
legend("topleft", col=c(1,2,2), legend=c("Actual measurement", "Prediction","90% prediction interval"), lty=c(NA,1,2), pch=c(21,NA,NA))
sigma.hat.pop <- sd(pop.final.residual)

n = length(pop)
t.val = qt(0.95, n-2) #critical value for 90% 
pred.x = 1:40
x = 1:15

sse <- sum((pop - pred.logis.fitted)^2)
mse <- sse / (n - 2)
pred.se.fit <- (1 + (1 / n) + (pred.x - mean(x))^2 / (sum((x - mean(x))^2))) # Standard error of the prediction
pred.logis.future.all.ub <- pred.logis.future.all + t.val * sqrt(mse * pred.se.fit)
pred.logis.future.all.lb <- pred.logis.future.all - t.val * sqrt(mse * pred.se.fit)
pop.final.sd = sqrt(mse * pred.se.fit) #2002:2041
lines(pred.logis.future.all.ub, type="l", lty=2, col=2)
lines(pred.logis.future.all.lb, type="l", lty=2, col=2)


############################################################################
## 3. Validation data (without sampling, but real validation data)
############################################################################

temp.gev = temp.gev.m1
load.gev = load.gev.m1


par(mfrow = c(1, 1))
n0 <- 1000
n1 <- 1000
n2 = 1000

# for non-stationary (non-homogeneous) GEV model: mu=mu0, sigma=sigma0, xi=xi0
# c(6,7,8)
length(temp.gev$mle)
temp.mu0 = temp.gev$mle[1]
temp.mu1 = temp.gev$mle[2]

temp.scale0 = temp.gev$mle[3]
temp.scale1 = temp.gev$mle[4]

temp.shape0 = temp.gev$mle[5]

length(load.gev$mle)
load.mu0 = load.gev$mle[1]
load.mu1 = load.gev$mle[2]
load.mu2 = load.gev$mle[3]
load.mu3 = load.gev$mle[4]

load.scale0 = load.gev$mle[5]
load.scale1 = load.gev$mle[6]
load.scale2 = load.gev$mle[7]
load.scale3 = load.gev$mle[8]

load.shape0 = load.gev$mle[9]

# validation with real data
val.gev.load <- matrix(NA,62*n1,6)
val.lm.load <- matrix(NA,62*n1,6)

temp.gev.mean = matrix(NA, 1,6)
temp.lm.mean = matrix(NA, 1,6)

for (i in c(1:6)){
  year= 2010+i
  print(year)
  
  samp.temp.gev = rgev(n1, 
                       loc=as.numeric(temp.mu0 + 
                                        temp.mu1*(test[test$year==year,]$GCM.summer.avg[1]) 
                       ),
                       scale= as.numeric(temp.scale0 + 
                                           temp.scale1*(test[test$year==year,]$GCM.summer.avg[1]) 
                       ),
                       shape=as.numeric(temp.shape0))

  temp.gev.mean[,i] = mean(samp.temp.gev)
  
  hist(test[test$year==year,]$temp.daily.max, freq = F, xlim=c(-5, 5), ylim=c(0,1), 
       main=paste("Histogram of daily peak temperature in ", year,sep = ""), xlab="standardized temperature")
  par(new=TRUE)
  plot(density(samp.temp.gev), lwd=2, col=4, xlim=c(-5, 5), ylim=c(0,1), main="", xlab="")
  legend("topleft", col=c('blue', 'red'), lwd=2, legend=c("GEV model", "LM"), cex=0.8, lty=c(1,2))
  
  #################################################
  # 2. sample population
  #################################################
  # sigma.hat.pop <- sd(pop.logis.residual)
  sigma.hat.pop <- sd(pop.final.residual)
  
  samp.pop <- rnorm(n0, mean= pred.logis.fitted[i], sd=sigma.hat.pop)
  samp.pop = samp.pop / 10000
  
  ##################################################
  # load
  ##################################################
  test.data = test[test$year == year,]
  test.data = test.data[complete.cases(test.data), ]
  for(l in 1:nrow(test.data)){
    mu= load.mu0 + 
      load.mu1*(test.data[l,]$temp.daily.max)+
      load.mu2*(test[(year-2011)*62+l,]$year.std) +
      load.mu3*pop[i+9]/10000
    
    scale = load.scale0 + 
      load.scale1*(test.data[l,]$temp.daily.max)+
      load.scale2*(test[(year-2011)*62+l,]$year.std) +
      load.scale3*pop[i+9]/10000  #scale should be positive
    shape = load.shape0
    
    mu = as.numeric(mu)
    scale = as.numeric(scale)
    shape = as.numeric(shape)
    val.gev.load[seq(1:n1)+n1*(l-1),i] = rgev(n1, loc=mu, scale=scale, shape=shape) 
  }
  d1 <- density(val.gev.load[1:(nrow(test.data)*n1),i])
  d1
  
  hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.0012) , xlab= "", 
       main= paste("Histogram of daily peak load in ", year,sep = ""))
  par(new=TRUE)
  plot(d1, xlim= c(7000,13000),ylim= c(0,0.0012), xlab= "", col= "blue", lwd=2, lty=1, main="")
  legend("topleft", legend=c('GEV', 'LM'),col=c('blue', 'red'), lwd=2,  lty=c(1,2))
  
  # real density
  loc=as.numeric(temp.mu0 + temp.mu1*(test[test$year==year,]$GCM.summer.avg[1]))
  scale= as.numeric(temp.scale0 + temp.scale1*(test[test$year==year,]$GCM.summer.avg[1]))
  shape=as.numeric(temp.shape0)
  den.gev = dgev(seq(-5,5,0.01),loc, scale, shape)
  hist(test[test$year==year,]$temp.daily.max, freq = F, xlim=c(-5, 5), ylim=c(0,1),
       main=paste("The daily peak temperature in ", year,sep = ""), xlab="standardized temperature")
  par(new=TRUE)
  plot(seq(-5,5,0.01), den.gev, lwd=2, col=4, type="l", ylim=c(0,1), xlab="", ylab="")

  if(year == 2011){
    d1.temp.gev.val.11 =den.gev
    d1.gev.val.11 = d1
  }else if(year == 2012){
    d1.temp.gev.val.12 =den.gev
    d1.gev.val.12 = d1
  }else if(year == 2013){
    d1.temp.gev.val.13 =den.gev
    d1.gev.val.13 = d1
  }else if(year == 2014){
    d1.temp.gev.val.14 =den.gev
    d1.gev.val.14 = d1
  }else if(year == 2015){
    d1.temp.gev.val.15 =den.gev
    d1.gev.val.15 = d1
  }else if(year == 2016){
    d1.temp.gev.val.16 =den.gev
    d1.gev.val.16 = d1
  }
}

par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right

# density for load
year =2011
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.11, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")

year =2012
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.12, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")


year =2013
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.13, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")


year =2014
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.14, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")

year =2015
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.15, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")

year =2016
hist(test$load[which(test$year==year)], freq = F, breaks=seq(7000,13000,500), xlim= c(7000,13000),ylim= c(0,0.001) , xlab= "", main="")
par(new=TRUE)
plot(d1.gev.val.16, xlim= c(7000,13000),ylim= c(0,0.001), xlab= "", col=2, lwd=2, lty=1, main="")
legend("topleft", col=2, lty =1, lwd=2, legend="Estimation")

#########################################################
# future predictions
#########################################################
gcm= read.table("tasmax.csv",sep= ",", header=F)
gcm= gcm[which(gcm$V2<=8),]
gcm= gcm[which(gcm$V2>=7),]
dim(gcm)
head(gcm)
time= gcm[,1:3]
gcm= gcm[,4:45]

# quantile for original GCM projections
col_numeric <- which( sapply(gcm, is.numeric ) )   # get numeric column indices
quantile( x = unlist( gcm[,  col_numeric] ),
          c(0, .25, .5, .75, 1),
          na.rm = TRUE )

GCM =cbind(time,gcm)
names(GCM)[1:3] = c("year", "month", "day")
GCM= GCM[which(GCM$year<=2016),]
GCM= GCM[which(GCM$year>=2002),]
head(GCM)

gcm.daily.ave = rowMeans(gcm, na.rm = FALSE, dims = 1)
gcm= cbind(time,gcm.daily.ave)
names(gcm) <- c("year","month","day","GCM.daily.avg")
gcm= as.data.frame(gcm)
head(gcm)

gcm.2017  = gcm[which(gcm$year>=2017),]
gcm.2017  = gcm.2017[which(gcm.2017$year<=2040),]


m= matrix(gcm$GCM.daily.avg, nrow=62)
head(m)
dim(m)
colMeans(m)
summer.avg= rep(colMeans(m),each=62)
gcm = cbind(gcm, summer.avg)
names(gcm)[5] = "GCM.summer.avg"

m.2017 = matrix(gcm.2017$GCM.daily.avg, nrow=62)
colMeans(m.2017)
summer.avg.2017= rep(colMeans(m.2017),each=62)

futureGCM = gcm.2017
unique(futureGCM$year)
futureGCM$year.std = futureGCM$year-2001
names(futureGCM) <- c("year","month","date","GCM.daily.avg", "year.std")

A= futureGCM[which(futureGCM$year<=2040),]
A= A[which(A$year>=2017),]
names(A)

m= matrix(A$GCM.daily.avg,62,length(unique(A$year)))
future.gcm.avg =as.data.frame(colMeans(m))
future.gcm.avg$year = 2017:2040
names(future.gcm.avg) = c("GCM.summer.avg", "year")


futureGCM$GCM.summer.avg = rep(future.gcm.avg$GCM.summer.avg, each=62)

# scale test
futureGCM$GCM.summer.avg <- scale(futureGCM$GCM.summer.avg, center = m.gcm.summer.avg, scale = sd.gcm.summer.avg)
head(futureGCM)
tail(futureGCM)

# final model 
data = data[complete.cases(data), ]
data$population =data$population*10 

head(data)
temp.gev.final <- gev.fit(xdat = data$temp.daily.max, ydat = as.matrix(data), mul  = c(7), sigl =  c(7))
temp.gev.final.mu0 = temp.gev.final$mle[1]
temp.gev.final.mu1 = temp.gev.final$mle[2]
temp.gev.final.scale0 = temp.gev.final$mle[3]
temp.gev.final.scale1 = temp.gev.final$mle[4]
temp.gev.final.shape0 = temp.gev.final$mle[5]

load.gev.final<- gev.fit(data$load, ydat= as.matrix(data), mul= c(4,8,9), sigl = c(4,8,9))
length(load.gev.final$mle)
load.gev.final.mu0 = load.gev.final$mle[1]
load.gev.final.mu1 = load.gev.final$mle[2]
load.gev.final.mu2 = load.gev.final$mle[3]
load.gev.final.mu3 = load.gev.final$mle[4]
load.gev.final.scale0 = load.gev.final$mle[5]
load.gev.final.scale1 = load.gev.final$mle[6]
load.gev.final.scale2 = load.gev.final$mle[7]
load.gev.final.scale3 = load.gev.final$mle[8]
load.gev.final.shape0 = load.gev.final$mle[9]

#########################################################

samp.temp.gev.final = matrix(NA, n1, n1)
n0=n1=n2=1000
samp.m1 <- matrix(NA,nrow=20, ncol= n0*n1*n2)


for (year in 2021:2040){
  print(year)
  
  ##################################################
  ## 1. sample the temperature
  ##################################################
  
  # temperature sample from GEV 
  samp.temp.gev = rgev(n1, loc = temp.gev.final.mu0 + 
                         # temp.gev.final.mu1*(futureGCM[(year-2017)*62+l,]$GCM.daily.avg) + 
                         temp.gev.final.mu1*(futureGCM[futureGCM$year==year,]$GCM.summer.avg[1]),
                       
                       scale=temp.gev.final.scale0 + 
                         temp.gev.final.scale1*(futureGCM[futureGCM$year==year,]$GCM.summer.avg[1]),
                       shape=temp.gev.final.shape0)
  ##################################################
  ## 2. sample the population
  ##################################################
  samp.pop.error <- rnorm(n0, mean= 0, sd=pop.final.sd[year-2001])
  samp.pop <- pred.logis.future[year-2016] + samp.pop.error
  samp.pop= samp.pop/1000
  
  samp.load.gev <- matrix(NA,n0^2,n1)
  # samp.load <- matrix(NA,n0,n1)
  for (j in 1:n0){
    for(k in 1:n1){
      mu= load.gev.final.mu0 + 
        load.gev.final.mu1*samp.temp.gev[k] + 
        load.gev.final.mu2*(year-2001) +
        load.gev.final.mu3*samp.pop[j]
      # load.gev.final.mu3*(samp.temp.gev[k])
      scale=load.gev.final.scale0 + 
        load.gev.final.scale1*samp.temp.gev[k] + 
        load.gev.final.scale2*(year-2001) +
        load.gev.final.scale3*samp.pop[j]
      shape = load.gev.final.shape0
      samp.load.gev[(j-1)*n1 + (1:n1),k] = rgev(n2, loc=mu, scale=scale, shape=shape)
    }
  }
  samp.m1[(year-2020),] <- c(samp.load.gev)
}

plot( density(samp.m1[1,],adjust = 20),xlim=c(7000,18000), ylim=c(0,0.0008), main="", col=1, xlab="Daily peak load (MW)")
lines(density(samp.m1[5,],adjust = 20), col=2)
lines(density(samp.m1[10,],adjust = 20), col=4)
lines(density(samp.m1[15,],adjust = 20), col=2, lty=2)
lines(density(samp.m1[20,],adjust = 20), col=4, lty=2)
legend("topleft", col=c(1,2,4,2,4), lwd=1, lty=c(1,1,1,2,2), legend=c(2021, 2025, 2030, 2035, 2040))

ds = read.csv("demand_saving_01_04.csv")
colnames(ds)=c("ds", 2021:2040)
ds[,1]=seq(0.1, 0.4, 0.01)
ds

# sensitivity - 2025
plot( density(samp.m1[5,],adjust = 20),xlim=c(7000,18000), ylim=c(0,0.0008), main="", col=1, xlab="Daily peak load (MW)")
lines(density(samp.m1[5,]-ds$`2025`[11],adjust = 20), col=2)
lines(density(samp.m1[5,]-ds$`2025`[21],adjust = 20), col=4, lty=2)
legend("topleft", col=c(1,2,4), lwd=1, lty=c(1,1,2),
       legend=c(expression(paste(d[s]," = 0",sep="") ),
                expression(paste(d[s]," = 0.2",sep="") ),
                expression(paste(d[s]," = 0.3",sep="") )
       ))

# sensitivity - 2030
plot( density(samp.m1[10,],adjust = 20),xlim=c(7000,18000), ylim=c(0,0.0008), main="", col=1, xlab="Daily peak load (MW)")
lines(density(samp.m1[10,]-ds$`2030`[11],adjust = 20), col=2)
lines(density(samp.m1[10,]-ds$`2030`[21],adjust = 20), col=4, lty=2)
legend("topleft", col=c(1,2,4), lwd=1, lty=c(1,1,2),
       legend=c(expression(paste(d[s]," = 0",sep="") ),
                expression(paste(d[s]," = 0.2",sep="") ),
                expression(paste(d[s]," = 0.3",sep="") )
       ))

# sensitivity - 2035
plot( density(samp.m1[15,],adjust = 20),xlim=c(7000,18000), ylim=c(0,0.0008), main="", col=1, xlab="Daily peak load (MW)")
lines(density(samp.m1[15,]-ds$`2035`[11],adjust = 20), col=2)
lines(density(samp.m1[15,]-ds$`2035`[21],adjust = 20), col=4, lty=2)
legend("topleft", col=c(1,2,4), lwd=1, lty=c(1,1,2),
       legend=c(expression(paste(d[s]," = 0",sep="") ),
                expression(paste(d[s]," = 0.2",sep="") ),
                expression(paste(d[s]," = 0.3",sep="") )
       ))

# sensitivity - 2040
plot( density(samp.m1[20,],adjust = 20),xlim=c(7000,18000), ylim=c(0,0.0008), main="", col=1, xlab="Daily peak load (MW)")
lines(density(samp.m1[20,]-ds$`2040`[11],adjust = 20), col=2)
lines(density(samp.m1[20,]-ds$`2040`[21],adjust = 20), col=4, lty=2)
legend("topleft", col=c(1,2,4), lwd=1, lty=c(1,1,2),
       legend=c(expression(paste(d[s]," = 0",sep="") ),
                expression(paste(d[s]," = 0.2",sep="") ),
                expression(paste(d[s]," = 0.3",sep="") )
       ))

round(c(mean(samp.m1[5,]-ds$`2025`[1]),quantile(samp.m1[5,]-ds$`2025`[1], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[5,]-ds$`2025`[6]),quantile(samp.m1[5,]-ds$`2025`[6], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[5,]-ds$`2025`[11]),quantile(samp.m1[5,]-ds$`2025`[11], c(0.5, 0.05, 0.95))))

# 2030
round(c(mean(samp.m1[10,]-ds$`2030`[1]),quantile(samp.m1[10,]-ds$`2030`[1], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[10,]-ds$`2030`[6]),quantile(samp.m1[10,]-ds$`2030`[6], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[10,]-ds$`2030`[11]),quantile(samp.m1[10,]-ds$`2030`[11], c(0.5, 0.05, 0.95))))

# 2035
round(c(mean(samp.m1[15,]-ds$`2035`[1]),quantile(samp.m1[15,]-ds$`2035`[1], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[15,]-ds$`2035`[6]),quantile(samp.m1[15,]-ds$`2035`[6], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[15,]-ds$`2035`[11]),quantile(samp.m1[15,]-ds$`2035`[11], c(0.5, 0.05, 0.95))))

# 2040
round(c(mean(samp.m1[20,]-ds$`2040`[1]),quantile(samp.m1[20,]-ds$`2040`[1], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[20,]-ds$`2040`[6]),quantile(samp.m1[20,]-ds$`2040`[6], c(0.5, 0.05, 0.95))))
round(c(mean(samp.m1[20,]-ds$`2040`[11]),quantile(samp.m1[20,]-ds$`2040`[11], c(0.5, 0.05, 0.95))))

demand.mean = matrix(NA, 20, 1)
for(i in 1:20){
  demand.mean[i] = mean(samp.m1[i,])
}

d.mean = as.data.frame(cbind(demand.mean, matrix(NA, 20, 31)))
rownames(d.mean) = 2021:2040
d.mean[,2] = demand.mean - as.numeric(ds[1,-1])
d.mean[,3] = demand.mean - as.numeric(ds[2,-1])
d.mean[,4] = demand.mean - as.numeric(ds[3,-1])
d.mean[,5] = demand.mean - as.numeric(ds[4,-1])
d.mean[,6] = demand.mean - as.numeric(ds[5,-1])
d.mean[,7] = demand.mean - as.numeric(ds[6,-1])
d.mean[,8] = demand.mean - as.numeric(ds[7,-1])
d.mean[,9] = demand.mean - as.numeric(ds[8,-1])
d.mean[,10] = demand.mean - as.numeric(ds[9,-1])
d.mean[,11] = demand.mean - as.numeric(ds[10,-1])
d.mean[,12] = demand.mean - as.numeric(ds[11,-1])
d.mean[,13] = demand.mean - as.numeric(ds[12,-1])
d.mean[,14] = demand.mean - as.numeric(ds[13,-1])
d.mean[,15] = demand.mean - as.numeric(ds[14,-1])
d.mean[,16] = demand.mean - as.numeric(ds[15,-1])
d.mean[,17] = demand.mean - as.numeric(ds[16,-1])
d.mean[,18] = demand.mean - as.numeric(ds[17,-1])
d.mean[,19] = demand.mean - as.numeric(ds[18,-1])
d.mean[,20] = demand.mean - as.numeric(ds[19,-1])
d.mean[,21] = demand.mean - as.numeric(ds[20,-1])
d.mean[,22] = demand.mean - as.numeric(ds[21,-1])
d.mean[,23] = demand.mean - as.numeric(ds[22,-1])
d.mean[,24] = demand.mean - as.numeric(ds[23,-1])
d.mean[,25] = demand.mean - as.numeric(ds[24,-1])
d.mean[,26] = demand.mean - as.numeric(ds[25,-1])
d.mean[,27] = demand.mean - as.numeric(ds[26,-1])
d.mean[,28] = demand.mean - as.numeric(ds[27,-1])
d.mean[,29] = demand.mean - as.numeric(ds[28,-1])
d.mean[,30] = demand.mean - as.numeric(ds[29,-1])
d.mean[,31] = demand.mean - as.numeric(ds[30,-1])
d.mean[,32] = demand.mean - as.numeric(ds[31,-1])

colnames(d.mean) = c(0,seq(0.1, 0.4, 0.01))


plot(c(2021:2040), d.mean[,1], type="l", xlab="Year", ylab="Predictive mean of daily peak load (MW)", 
     ylim=c(9000, 17000), col=1)
for(i in 2:32){
  lines(c(2021:2040), d.mean[,i])
}

plot(c(2021:2040), d.mean[,1], type="l", xlab="Year", ylab="Predictive mean of daily peak load (MW)", 
     ylim=c(9000, 17000), col=1, xaxt = "n")
lines(c(2021:2040), d.mean[,2], col=2, lty=2)
lines(c(2021:2040), d.mean[,12], col=2, lty=3)
lines(c(2021:2040), d.mean[,22], col=4, lty=2)
lines(c(2021:2040), d.mean[,32], col=4, lty=3)

legend("topleft", col=c(1,2,2,4,4), lwd=1, lty=c(1,2,3,2,3),
       legend=c(expression(paste(d[s]," = 0",sep="") ),
                expression(paste(d[s]," = 0.1",sep="") ),
                expression(paste(d[s]," = 0.2",sep="") ),
                expression(paste(d[s]," = 0.3",sep="") ),
                expression(paste(d[s]," = 0.4",sep="") )
       ))
axis(1, at=2021:2040, labels=c(2021:2040)) 

# population
plot(c(2002:2016), pop, xlab="Year", ylab="Population (in thousands)")

# demand
boxplot(data.origin$load~ data.origin$year , main="", xlab="Year", ylab="Daily peak demand (MW)")

